# notation according to article: x = r, y = z 
reset
# pricipal stresses 
sig1 = 1.0 # sig2 = 1.0
sig3 = 4.0
taumax = abs(sig3 - sig1)/2 # extreme shear stress
circle(x, y) = sqrt(x**2 + y**2) - 1
# shear stresses as a function of radial coordinate x and vertical coordinate y
tau(x, y, sig1, sig3) = sqrt((sig1-sig3)**2 * x**2 * y**2) - taumax
set terminal wxt
set view map
unset surface
set contour # contour plot
set xrange [-2:2.5]
set yrange [-2:2.5]
set isosample 100, 100
set cntrparam levels discrete 0
# contour plot of the unit circle onto file 'circle.dat'
set table "circle.dat" 
splot circle(x,y) 
unset table
# contour plot of function tau is taumax onto file 'tau.dat'
set table "tau.dat" 
splot tau(x,y,sig1,sig3) 
unset table

plot "stationarypoints.dat" u 1:2 w p pt 7 ps 3 lc 9 notitle, \
  "" u 1:2:1:2 w vectors lc 9 notitle, \
     "tau.dat" u 1:2 w l lw 4 lt 1 lc 0 t "tau is taumax", \
     "circle.dat" u 1:2 w l lw 4 lt 1 lc 9 t "unit circle"
set xlabel "r"; set ylabel "z"
set size square
replot

