# attach('tauplot.sage')
def ball(x,y,z): 
    return sqrt(x^2+y^2+z^2)
def tau(x,y,z, sig1=1,sig2=2,sig3=3): 
    return ball( (sig1-sig2)*x*y, (sig1-sig3)*x*z, (sig2-sig3)*y*z )
def plotUnitBall(c):
    [x,y,z] = var('x,y,z')
    return implicit_plot3d(ball(x,y,z), (x,-1.5,1.5),(y,-1.5,1.5),(z,-1.5,1.5),  \
                           plot_points=50, contour=1, color=c, opacity=1)
def plotTauIsConst(c, sig1=1,sig2=2,sig3=3, isp=0):	
    tausp = map(abs,[(sig3-sig2)/2, (sig3-sig1)/2, (sig2-sig1)/2])
    [x,y,z] = var('x,y,z')
    return implicit_plot3d(tau(x,y,z,sig1,sig2,sig3), (x,-2,2),(y,-2,2),(z,-2,2), \
                       plot_points=100, contour=tausp[isp], color=c, opacity=1)
def plotStationaryPoints(p, c):
    return point(p, rgbcolor=c, pointsize=150) 
def plotStationaryArrow(p1, p2, c):
    return arrow(p1,p2, rgbcolor=c, width=2, arrowsize=5)
def plotStationaryText(t, p):
    return text3d(t,p*1.05, fontsize=80, color='black')
def plotCoordinateSystem(c):
    COOR = matrix([[1,0,0],[0,1,0],[0,0,1]])*3
    return (sum(arrow((0,0,0),COOR[i], rgbcolor=c, width=2, arrowsize=5) for i in [0..2]) + \
            sum(text3d(i+1,COOR[i]*1.05,fontsize=12,color=c) for i in [0..2]))

def tauplot(sig1=1,sig2=2,sig3=3, isp=1):
    isp = isp - 1	
    col = ['green', 'blue', 'yellow'] # stationary point colors 
    txt = ["I", "II", "III"] # stationary points annotations
# plot of the unit ball 
    B1 = plotUnitBall('blue') # isosurface
# plot of the surface tau = const
    T = plotTauIsConst('red', sig1,sig2,sig3, isp) # isosurface
# stationary points
    SP1 = matrix([[0,-1,-1],[0,-1,1],[0,1,-1],[0,1,1]])*sqrt(2)/2 # stationary points for isp=1
    SP2 = matrix([[-1,0,-1],[-1,0,1],[1,0,-1],[1,0,1]])*sqrt(2)/2 # stationary points for isp=2
    SP3 = matrix([[-1,-1,0],[-1,1,0],[1,-1,0],[1,1,0]])*sqrt(2)/2 # stationary points for isp=3
    SP = [SP1, SP2, SP3] # all stationary points
# stationary points annotation
    S  = plotStationaryPoints(SP[isp],col[isp]) # points
    TS = sum(plotStationaryText(txt[isp],SP[isp][i]*2) for i in [0..3]) # text
    AS = sum(plotStationaryArrow(SP[isp][i],SP[isp][i]*2,col[isp]) for i in [0..3]) # gradients
# plot Cartesian coordinate system with basis e1, e2 and e3
    CS = plotCoordinateSystem('black') # axes + text
# join all figure parts
    P = T+B1+S+AS+TS+CS # tau is const + unit sphere + stationary points + coor system
    return P

# tests
# P = tauplot(1,2,4,0)
# P.show(viewer='jmol', frame=false, figsize=[10,10], aspect_ratio=1)

# vec slik naenkrat
# h = sum(P[i].translate((8*i,0,0)) for i in range(len(P)))


